// Copyright (C) 2013 - Michael Baudin
// Copyright (C) 2012 - Maria Christopoulou
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution. The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt␊

// <-- CLI SHELL MODE -->

function checkPdist(X,D)
    m=size(X,"r")
    k=1;
    for j=1:m
        for i=j+1:m
            if (i==j) then
                continue
            end
            dij=norm(X(i,:)-X(j,:));
            mprintf("%s: Checking [%d,%d]…\n", "checkPdist",i,j)
            assert_checkalmostequal(D(k),dij);
            k=k+1;
        end
    end
    mprintf("%s: OK\n","checkPdist")
endfunction

// Results confirmed from licensed Matlab version R2011b
X = [
0.3185689    0.684731   
0.7688531    0.3089766  
0.5430379    0.5694503  
0.9205527    0.1715891  
0.1097627    0.9247127
];
D = scidoe_pdist(X);
Dexpected = [0.5865 0.2523 0.7910 0.3181 0.3447 0.2047 0.9020 0.5485 0.5603 1.1066];
assert_checkalmostequal(D,Dexpected,1.0e-3);
checkPdist(X,D);
//
X  =[
    0.7388326    0.3958625    0.7399886    0.2840223    0.9180394  
    0.1917208    0.9060844    0.2644475    0.6963924    0.4627983
    ];
D = scidoe_pdist(X);
Dexpected = 1.0787;
assert_checkalmostequal(D,Dexpected,1.0e-3);
checkPdist(X,D);
//
// Check if empty matrix is generated when we have only one sample point
X = [0.3682415    0.8326198    0.9571552];
D = scidoe_pdist(X);
Dexpected = [];
assert_checkequal(D,Dexpected);
checkPdist(X,D);
//
// In dimension 3
X = [
    0.8147237    0.9688678    0.0975404  
    0.135477     0.9133759    0.5472206  
    0.9057919    0.2210340    0.2784982  
    0.8350086    0.6323592    0.1883820  
    0.1269868    0.3081671    0.5468815  
];
D = scidoe_pdist(X);
checkPdist(X,D);
